#
# editor.rb
#
#   Copyright (c) 2001 Minero Aoki <aamine@loveruby.net>
#
#   This program is free software.
#   you can distribute/modify this program under the terms of
#   the GNU General Public License version 2 or later.
#

module Delta

  class ExternalEditor

    def initialize( cmd )
      @command = cmd
      sprintf @command, 'tmpfile'   # to check
    end

    def edit( port )
      tmpfile = sprintf( '/tmp/delta_%x_%x', $$, port.id )
      File.open( tmpfile, 'w' ) {|w|
          port.ropen {|r| w.write r.read }
      }

      stamp = File.mtime( tmpfile )
      begin
        if system sprintf(@command, tmpfile) and
                File.mtime(tmpfile) > stamp then   # edit&saved
          port.wopen {|w|
              File.open( tmpfile ) {|r| w.write r.read }
          }
        end
      ensure
        File.unlink tmpfile
      end
    end

  end

end
